(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('reflect-metadata'), require('lodash'), require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('rx-form-mapper', ['exports', 'reflect-metadata', 'lodash', '@angular/core', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['rx-form-mapper'] = {}, null, global.lodash, global.ng.core, global.ng.forms));
}(this, (function (exports, reflectMetadata, lodash, core, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var isNotNil = lodash.negate(lodash.isNil);
    function coerceArray(value) {
        return lodash.castArray(value).filter(isNotNil);
    }
    function isType(value) {
        return lodash.isFunction(value);
    }

    var ValidableMetadata = /** @class */ (function () {
        function ValidableMetadata() {
            this._validators = [];
            this._asyncValidators = [];
        }
        ValidableMetadata.prototype.setValidators = function (opts) {
            this._validators = coerceArray(opts === null || opts === void 0 ? void 0 : opts.validators);
            this._asyncValidators = coerceArray(opts === null || opts === void 0 ? void 0 : opts.asyncValidators);
            this._updateOn = opts === null || opts === void 0 ? void 0 : opts.updateOn;
        };
        Object.defineProperty(ValidableMetadata.prototype, "validators", {
            get: function () {
                return this._validators;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidableMetadata.prototype, "asyncValidators", {
            get: function () {
                return this._asyncValidators;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidableMetadata.prototype, "updateOn", {
            get: function () {
                return this._updateOn;
            },
            enumerable: false,
            configurable: true
        });
        return ValidableMetadata;
    }());

    var CustomControlMetadata = /** @class */ (function (_super) {
        __extends(CustomControlMetadata, _super);
        function CustomControlMetadata(mapper) {
            var _this = _super.call(this) || this;
            _this.mapper = mapper;
            return _this;
        }
        CustomControlMetadata.prototype.accept = function (visitor) {
            return visitor.visitCustomControlMetadata(this);
        };
        return CustomControlMetadata;
    }(ValidableMetadata));

    var FormArrayMetadata = /** @class */ (function (_super) {
        __extends(FormArrayMetadata, _super);
        function FormArrayMetadata(itemForm) {
            var _this = _super.call(this) || this;
            _this.itemForm = itemForm;
            return _this;
        }
        FormArrayMetadata.prototype.accept = function (visitor) {
            return visitor.visitFormArrayMetadata(this);
        };
        return FormArrayMetadata;
    }(ValidableMetadata));

    var FormControlMetadata = /** @class */ (function (_super) {
        __extends(FormControlMetadata, _super);
        function FormControlMetadata() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormControlMetadata.prototype.accept = function (visitor) {
            return visitor.visitFormControlMetadata(this);
        };
        return FormControlMetadata;
    }(ValidableMetadata));

    var FormGroupMetadata = /** @class */ (function () {
        function FormGroupMetadata(form) {
            this.form = form;
        }
        FormGroupMetadata.prototype.accept = function (visitor) {
            return visitor.visitFormGroupMetadata(this);
        };
        return FormGroupMetadata;
    }());

    var FormMetadata = /** @class */ (function (_super) {
        __extends(FormMetadata, _super);
        function FormMetadata(type) {
            var _this = _super.call(this) || this;
            _this.type = type;
            _this._controls = {};
            return _this;
        }
        FormMetadata.prototype.accept = function (visitor) {
            return visitor.visitFormMetadata(this);
        };
        Object.defineProperty(FormMetadata.prototype, "controls", {
            get: function () {
                return this._controls;
            },
            enumerable: false,
            configurable: true
        });
        FormMetadata.prototype.setFormControl = function (name, opts) {
            var control = new FormControlMetadata();
            control.setValidators(opts);
            this.controls[name] = control;
        };
        FormMetadata.prototype.setFormGroup = function (name, form) {
            var control = new FormGroupMetadata(form);
            this.controls[name] = control;
        };
        FormMetadata.prototype.setCustomControl = function (name, mapper, opts) {
            var control = new CustomControlMetadata(mapper);
            control.setValidators(opts);
            this.controls[name] = control;
        };
        FormMetadata.prototype.setFormArray = function (name, itemform, opts) {
            var control = new FormArrayMetadata(itemform);
            control.setValidators(opts);
            this.controls[name] = control;
        };
        return FormMetadata;
    }(ValidableMetadata));

    var ModelBinder = /** @class */ (function () {
        function ModelBinder() {
            this.metadataKey = 'rx-form-mapper-metadata';
        }
        ModelBinder.prototype.getMetadata = function (target) {
            if (!Reflect.hasMetadata(this.metadataKey, target)) {
                Reflect.defineMetadata(this.metadataKey, new FormMetadata(target), target);
            }
            return Reflect.getMetadata(this.metadataKey, target);
        };
        ModelBinder.prototype.bindForm = function (target, opts) {
            var formMetadata = this.getMetadata(target);
            formMetadata.setValidators(opts);
        };
        ModelBinder.prototype.bindCustomControl = function (target, propertyName, opts) {
            this.getMetadata(target.constructor).setCustomControl(propertyName, opts.mapper, opts);
        };
        ModelBinder.prototype.bindFormControl = function (target, propertyName, opts) {
            this.getMetadata(target.constructor).setFormControl(propertyName, opts);
        };
        ModelBinder.prototype.bindFormGroup = function (target, propertyName, type) {
            var propertyType = type !== null && type !== void 0 ? type : Reflect.getMetadata(exports.MetadataDesignTypes.TYPE, target, propertyName);
            var propertyFormMetadata = this.getMetadata(propertyType);
            this.getMetadata(target.constructor).setFormGroup(propertyName, propertyFormMetadata);
        };
        ModelBinder.prototype.bindFormArray = function (target, propertyName, opts) {
            var itemFormMetadata = this.getMetadata(opts.type);
            this.getMetadata(target.constructor).setFormArray(propertyName, itemFormMetadata, opts);
        };
        return ModelBinder;
    }());
    ModelBinder.instance = new ModelBinder();

    (function (MetadataDesignTypes) {
        MetadataDesignTypes["TYPE"] = "design:type";
        MetadataDesignTypes["RETURN_TYPE"] = "design:returntype";
        MetadataDesignTypes["PARAM_TYPE"] = "design:paramtypes";
    })(exports.MetadataDesignTypes || (exports.MetadataDesignTypes = {}));

    function CustomControl(optsOrMapper) {
        return function (target, propertyName) {
            if (lodash.isNil(optsOrMapper)) {
                throw new Error("unexpected CustomControl configuration: " + optsOrMapper);
            }
            if (typeof (optsOrMapper) !== 'object') {
                optsOrMapper = { mapper: optsOrMapper };
            }
            ModelBinder.instance.bindCustomControl(target, propertyName, optsOrMapper);
        };
    }

    function FormArray(optsOrType) {
        return function (target, propertyName) {
            if (lodash.isNil(optsOrType)) {
                throw new Error("unexpected FormArray configuration: " + optsOrType);
            }
            if (isType(optsOrType)) {
                optsOrType = { type: optsOrType };
            }
            ModelBinder.instance.bindFormArray(target, propertyName, optsOrType);
        };
    }

    function FormControl(opts) {
        return function (target, propertyName) {
            ModelBinder.instance.bindFormControl(target, propertyName, opts);
        };
    }

    function FormGroup(type) {
        return function (target, propertyName) {
            ModelBinder.instance.bindFormGroup(target, propertyName, type);
        };
    }

    function Form(opts) {
        return function (target) {
            ModelBinder.instance.bindForm(target, opts);
        };
    }

    var CustomMapperResolver = /** @class */ (function () {
        function CustomMapperResolver(injector) {
            this.injector = injector;
        }
        CustomMapperResolver.prototype.resolve = function (type) {
            var _a;
            return (_a = this.injector.get(type, null, core.InjectFlags.Optional)) !== null && _a !== void 0 ? _a : new type();
        };
        return CustomMapperResolver;
    }());
    CustomMapperResolver.decorators = [
        { type: core.Injectable }
    ];
    CustomMapperResolver.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };

    var FormReader = /** @class */ (function () {
        function FormReader(control, customMapperResolver) {
            this.control = control;
            this.customMapperResolver = customMapperResolver;
        }
        FormReader.prototype.visitCustomControlMetadata = function (customControlMetadata) {
            return this.customMapperResolver.resolve(customControlMetadata.mapper).readForm(this.control);
        };
        FormReader.prototype.visitFormArrayMetadata = function (formArrayMetadata) {
            var _this = this;
            if (!this.control) {
                return void (0);
            }
            this.checkControlType(this.control, forms.FormArray);
            return this.control.controls.map(function (control) {
                var subFormReader = _this.copyPrototype(control);
                return formArrayMetadata.itemForm.accept(subFormReader);
            });
        };
        FormReader.prototype.visitFormControlMetadata = function (formControlMetadata) {
            if (!this.control) {
                return void (0);
            }
            this.checkControlType(this.control, forms.FormControl);
            return this.control.value;
        };
        FormReader.prototype.visitFormGroupMetadata = function (formGroupMetadata) {
            return this.visitFormMetadata(formGroupMetadata.form);
        };
        FormReader.prototype.visitFormMetadata = function (formMetadata) {
            var e_1, _a;
            if (!this.control) {
                return void (0);
            }
            this.checkControlType(this.control, forms.FormGroup);
            var value = new formMetadata.type();
            var formGroup = this.control;
            try {
                for (var _b = __values(Object.entries(formMetadata.controls)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var _d = __read(_c.value, 2), key = _d[0], controlMetadata = _d[1];
                    var formField = formGroup.controls[key];
                    var formFieldReader = this.copyPrototype(formField);
                    value[key] = controlMetadata.accept(formFieldReader);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return value;
        };
        FormReader.prototype.copyPrototype = function (control) {
            return new FormReader(control, this.customMapperResolver);
        };
        FormReader.prototype.checkControlType = function (control, type) {
            if (control instanceof type) {
                return;
            }
            throw new Error("control is not " + type.name + " instance");
        };
        return FormReader;
    }());

    var FormWriter = /** @class */ (function () {
        function FormWriter(value, customMapperResolver, validatorResolver) {
            this.value = value;
            this.customMapperResolver = customMapperResolver;
            this.validatorResolver = validatorResolver;
        }
        FormWriter.prototype.visitCustomControlMetadata = function (customControlMetadata) {
            var mapper = this.customMapperResolver.resolve(customControlMetadata.mapper);
            return mapper.writeForm(this.value, this.buildAbstractControlOptions(customControlMetadata));
        };
        FormWriter.prototype.visitFormArrayMetadata = function (formArrayMetadata) {
            var e_1, _b;
            var _a;
            var values = (_a = this.value) !== null && _a !== void 0 ? _a : [];
            var controls = [];
            try {
                for (var values_1 = __values(values), values_1_1 = values_1.next(); !values_1_1.done; values_1_1 = values_1.next()) {
                    var item = values_1_1.value;
                    var subWriter = this.copyPrototype(item);
                    var control = formArrayMetadata.itemForm.accept(subWriter);
                    controls.push(control);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (values_1_1 && !values_1_1.done && (_b = values_1.return)) _b.call(values_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return new forms.FormArray(controls, this.buildAbstractControlOptions(formArrayMetadata));
        };
        FormWriter.prototype.visitFormControlMetadata = function (formControlMetadata) {
            return new forms.FormControl(this.value, this.buildAbstractControlOptions(formControlMetadata));
        };
        FormWriter.prototype.visitFormGroupMetadata = function (formGroupMetadata) {
            return this.visitFormMetadata(formGroupMetadata.form);
        };
        FormWriter.prototype.visitFormMetadata = function (formMetadata) {
            var e_2, _b;
            var _a;
            var controls = {};
            try {
                for (var _c = __values(Object.entries(formMetadata.controls)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var _e = __read(_d.value, 2), key = _e[0], controlMetadata = _e[1];
                    var fieldValue = (_a = this.value) === null || _a === void 0 ? void 0 : _a[key];
                    var subWriter = this.copyPrototype(fieldValue);
                    controls[key] = controlMetadata.accept(subWriter);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return new forms.FormGroup(controls, this.buildAbstractControlOptions(formMetadata));
        };
        FormWriter.prototype.buildAbstractControlOptions = function (metadata) {
            var _this = this;
            return {
                validators: metadata.validators.map(function (v) { return _this.validatorResolver.resolve(v); }),
                asyncValidators: metadata.asyncValidators.map(function (v) { return _this.validatorResolver.resolve(v); }),
                updateOn: metadata.updateOn
            };
        };
        FormWriter.prototype.copyPrototype = function (value) {
            return new FormWriter(value, this.customMapperResolver, this.validatorResolver);
        };
        return FormWriter;
    }());

    var ValidatorResolver = /** @class */ (function () {
        function ValidatorResolver(injector) {
            this.injector = injector;
        }
        ValidatorResolver.prototype.resolve = function (validator) {
            if (this.isValidatorFn(validator)) {
                return validator;
            }
            var validatorInstance = null;
            if (this.isValidatorInstance(validator)) {
                validatorInstance = validator;
            }
            else {
                validatorInstance = this.injector.get(validator, null, core.InjectFlags.Optional);
                validatorInstance !== null && validatorInstance !== void 0 ? validatorInstance : (validatorInstance = new validator());
            }
            return function (c) { return validatorInstance.validate(c); };
        };
        ValidatorResolver.prototype.isValidatorFn = function (value) {
            return lodash.isFunction(value) && !value.prototype.validate;
        };
        ValidatorResolver.prototype.isValidatorInstance = function (value) {
            return 'validate' in value;
        };
        return ValidatorResolver;
    }());
    ValidatorResolver.decorators = [
        { type: core.Injectable }
    ];
    ValidatorResolver.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };

    var RxFormMapper = /** @class */ (function () {
        function RxFormMapper(customMapperResolver, validatorResolver) {
            this.customMapperResolver = customMapperResolver;
            this.validatorResolver = validatorResolver;
        }
        RxFormMapper.prototype.fromType = function (type) {
            if (lodash.isNil(type)) {
                throw new Error('type cannot be inferred implicitly');
            }
            var formWriter = new FormWriter(void (0), this.customMapperResolver, this.validatorResolver);
            return ModelBinder.instance.getMetadata(type).accept(formWriter);
        };
        RxFormMapper.prototype.writeForm = function (value, type) {
            if (lodash.isNil(value) && lodash.isNil(type)) {
                throw new Error('type cannot be inferred implicitly');
            }
            var valueType = type !== null && type !== void 0 ? type : Object.getPrototypeOf(value).constructor;
            var formWriter = new FormWriter(value, this.customMapperResolver, this.validatorResolver);
            return ModelBinder.instance.getMetadata(valueType).accept(formWriter);
        };
        RxFormMapper.prototype.readForm = function (form, type) {
            if (lodash.isNil(type)) {
                throw new Error('type cannot be inferred implicitly');
            }
            var formReader = new FormReader(form, this.customMapperResolver);
            return ModelBinder.instance.getMetadata(type).accept(formReader);
        };
        return RxFormMapper;
    }());
    RxFormMapper.decorators = [
        { type: core.Injectable }
    ];
    RxFormMapper.ctorParameters = function () { return [
        { type: CustomMapperResolver },
        { type: ValidatorResolver }
    ]; };

    var RxFormMapperModule = /** @class */ (function () {
        function RxFormMapperModule(parentModule) {
            if (parentModule) {
                throw new Error('RxFormMapperModule is already loaded. Import it in the AppModule only');
            }
        }
        RxFormMapperModule.forRoot = function () {
            return {
                ngModule: RxFormMapperModule,
                providers: [
                    RxFormMapper,
                    CustomMapperResolver,
                    ValidatorResolver
                ]
            };
        };
        return RxFormMapperModule;
    }());
    RxFormMapperModule.decorators = [
        { type: core.NgModule }
    ];
    RxFormMapperModule.ctorParameters = function () { return [
        { type: RxFormMapperModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    /*
     * Public API Surface of rx-form-mapper
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CustomControl = CustomControl;
    exports.CustomControlMetadata = CustomControlMetadata;
    exports.CustomMapperResolver = CustomMapperResolver;
    exports.Form = Form;
    exports.FormArray = FormArray;
    exports.FormArrayMetadata = FormArrayMetadata;
    exports.FormControl = FormControl;
    exports.FormControlMetadata = FormControlMetadata;
    exports.FormGroup = FormGroup;
    exports.FormGroupMetadata = FormGroupMetadata;
    exports.FormMetadata = FormMetadata;
    exports.FormReader = FormReader;
    exports.FormWriter = FormWriter;
    exports.ModelBinder = ModelBinder;
    exports.RxFormMapper = RxFormMapper;
    exports.RxFormMapperModule = RxFormMapperModule;
    exports.ValidableMetadata = ValidableMetadata;
    exports.ValidatorResolver = ValidatorResolver;
    exports.coerceArray = coerceArray;
    exports.isType = isType;
    exports.ɵa = RxFormMapper;
    exports.ɵb = CustomMapperResolver;
    exports.ɵc = ValidatorResolver;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=rx-form-mapper.umd.js.map
