import { Type } from '@angular/core';
import 'reflect-metadata';
import { RxValidator, RxAsyncValidator } from '..';
import { CustomControlMapper } from '../interfaces/custom-control-mapper';
import { UpdateOn } from '../types';
export interface CustomControlOpts {
    mapper: Type<CustomControlMapper>;
    validators?: RxValidator | RxValidator[];
    asyncValidators?: RxAsyncValidator | RxAsyncValidator[];
    updateOn?: UpdateOn;
}
export declare function CustomControl(mapper: Type<CustomControlMapper>): (target: any, propertyName: string) => void;
export declare function CustomControl(opts: CustomControlOpts): (target: any, propertyName: string) => void;
