import { Type } from '@angular/core';
import { CustomControlMapper } from '../interfaces';
import { ControlVisitor } from './control-visitor';
import { ValidableMetadata } from './validable-metadata';
export declare class CustomControlMetadata extends ValidableMetadata {
    readonly mapper: Type<CustomControlMapper>;
    constructor(mapper: Type<CustomControlMapper>);
    accept<T>(visitor: ControlVisitor<T>): T;
}
