import { Type } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { CustomMapperResolver } from './custom-mapper-resolver';
import { ValidatorResolver } from './validator-resolver';
export declare class RxFormMapper {
    private readonly customMapperResolver;
    private readonly validatorResolver;
    constructor(customMapperResolver: CustomMapperResolver, validatorResolver: ValidatorResolver);
    fromType<T>(type: Type<T>): FormGroup;
    writeForm<T>(value: T): FormGroup;
    writeForm<T>(value: T, type: Type<T>): FormGroup;
    readForm<T>(form: FormGroup, type: Type<T>): T;
}
