import { Injector } from '@angular/core';
import { AsyncValidatorFn, ValidatorFn } from '@angular/forms';
import { RxAsyncValidator, RxValidator } from '../types';
export declare class ValidatorResolver {
    private readonly injector;
    constructor(injector: Injector);
    resolve(validator: RxAsyncValidator): AsyncValidatorFn;
    resolve(validator: RxValidator): ValidatorFn;
    private isValidatorFn;
    private isValidatorInstance;
}
